import stainless.collection._

object Exercise3 {
  def positiveAdd(a: BigInt, b: BigInt): BigInt = {
    require(a >= 0 && b >= 0)
    a + b
  } ensuring(res =>
    res >= 0
  )

  def isSorted(l: List[BigInt]): Boolean = {
    l match {
      case Nil() => true
      case Cons(x, Nil()) => true
      case Cons(x, xs @ Cons(y, ys)) => x <= y && isSorted(xs)
    }
  }

  def insert(x: BigInt, l: List[BigInt]): List[BigInt] = {
    require(isSorted(l))
    l match {
      case Nil() => Cons(x, Nil())
      case Cons(y, ys) =>
        if (x < y) Cons(x, l)
        else Cons(y, insert(x, ys))
    }
  } ensuring(res => isSorted(res))
}
